Please install functorch first: https://github.com/pytorch/functorch

For the sequential rounds attack, you can try to run non-iid cifar10 by:

baseline:
`python training.py --name exp1_base --fl-sample-dirichlet --fl-no-models 10 --fl-attack-freq 100 200 1 --loss-balance fixed --fixed-scales 1 --loss-tasks backdoor --update-method avg --fl-dp-clip 0.5 --fl-attacker-local-epochs 2 --fl-local-epochs 2 --lr 0.01 --params configs/cifar_fed.yaml --epochs 500`

anticipate:
`python training.py --name exp1_anticipate --fl-sample-dirichlet --fl-no-models 10 --fl-attack-freq 100 200 1 --meta-attack --meta-steps 9 --loss-balance fixed --fixed-scales 1 --loss-tasks backdoor --update-method avg --fl-dp-clip 0.5 --fl-attacker-local-epochs 4 --fl-local-epochs 2 --lr 0.01 --params configs/cifar_fed.yaml --epochs 500`

For the random rounds attack, you can try to run non-iid cifar10 by:

baseline:
`python training.py --name exp2_base --fl-sample-dirichlet --fl-no-models 10 --fl-attack-freq 0 500 100 0 --loss-balance fixed --fixed-scales 1 --loss-tasks backdoor --update-method avg --fl-dp-clip 0.5 --fl-attacker-local-epochs 2 --fl-local-epochs 2 --lr 0.01 --params configs/cifar_fed.yaml --epochs 2000`

anticipate:
`python training.py --name exp2_anticipate --fl-sample-dirichlet --fl-no-models 10 --fl-attack-freq 0 500 100 0 --meta-attack --meta-steps 9 --loss-balance fixed --fixed-scales 1 --loss-tasks backdoor --update-method avg --fl-dp-clip 0.5 --fl-attacker-local-epochs 4 --fl-local-epochs 2 --lr 0.01 --params configs/cifar_fed.yaml --epochs 2000`

after running, you can check the tensorboard log under /runs